// FS6IPC Interface - originally by Jason Grooms
// Modified by Alessandro Antonini to support FS98 
// sorry, i have no time to comment or document changes - refer to
// included sample

// NOTE: my D3 version gives uncorrect values with F.P. single and double 
// types. Therefore i changed them with extended.

//--------------------------------------------------------------------------//
{.$WEAKPACKAGEUNIT}

//--------------------------------------------------------------------------//
Unit Fs6State;

//--------------------------------------------------------------------------//
{$A-} // don't align records

//--------------------------------------------------------------------------//
Interface

//--------------------------------------------------------------------------//
Uses Windows;


//--------------------------------------------------------------------------//
Const
    FS6IPC_MESSAGENAME       = 'FSASMLIB:IPC';
    FS6IPC_MESSAGE_SUCCESS   = 1;
    FS6IPC_MESSAGE_FAILURE   = 0;
    FS6IPC_READSTATEDATA_ID  = 1;
    FS6IPC_WRITESTATEDATA_ID = 2;

type
    FS6IPC_READSTATEDATA_HDR = record
    dwId     : dword;
    dwOffset : dword;
    nBytes   : dword;
    pDest    : pointer;
  end; { tagFS6IPC_READSTATEDATA_HDR }

  FS6IPC_WRITESTATEDATA_HDR = record
    dwId     : dword;
    dwOffset : dword;
    nBytes   : dword;
  end; { tagFS6IPC_WRITESTATEDATA_HDR }

//--------------------------------------------------------------------------//
Const
    // General Constants
    FtPerMtr = 3.2808;

   // Wind Types
  wtSteady = 0;
  wtGusty  = 1;

  // Clouds Types
  ctUserDefined   = 0;
  ctCirrus        = 1;
  ctCirroStratus  = 2;
  ctCirroCumulus  = 3;
  ctAltoStratus   = 4;
  ctAltoCumulus   = 5;
  ctStratoCumulus = 6;
  ctNimboStratus  = 7;
  ctStratus       = 8;
  ctCumulus       = 9;
  ctCumuloNimbus  = 10;

  // Cloud Coverage Types
  ctHazeOnly    = $0000;
  ctScattered18 = 8192;
  ctScattered28 = 16384;
  ctScattered38 = 24576;
  ctScattered48 = 32768;
  ctBroken58    = 40960;
  ctBroken68    = 49152;
  ctBroken78    = 57344;
  ctOvercast    = $FFFF;

  // Visibility Ranges
  vrUnlimited = 32000;
  vr50nms     = 05000;
  vr40nms     = 04000;
  vr30nms     = 03000;
  vr25nms     = 02500;
  vr20nms     = 02000;
  vr15nms     = 01500;
  vr10nms     = 01000;
  vr7nms      = 00700;
  vr5nms      = 00500;
  vr4nms      = 00400;
  vr3nms      = 00300;
  vr2_5nms    = 00250;
  vr2nms      = 00200;
  vr1nms      = 00100;
  vr_34nms    = 00075;
  vr_12nms    = 00050;
  vr_38nms    = 00037;
  vr_14nms    = 00025;
  vr_18nms    = 00013;
  vr_116nms   = 00006;

  { Variable Offset Constants }
  fsClockHour           = $0238;
  fsClockMin            = $0239;
  fsClockSec            = $023A;
  fsPauseFlag           = $0268;
  fsLightsFlag          = $0288;
  fsStrobeFlag          = $0289;
  fsStrobeTimer         = $028A;
  fsLandingLightFlag    = $0298;
  fsSpoilers            = $029E;
  fsMagVar              = $02A0;
  fsTickCount           = $02A8;
  fsFrameTime           = $02AA;
  fsTAS                 = $02B4;
  fsIAS                 = $02B8;
  fsADFFreq             = $0356;
  fsCOM1Freq            = $0358;
  fsNAV1Freq            = $035A;
  fsNAV2Freq            = $035C;
  fsXPNDRCode           = $035E;
  fsLatLo               = $05A8;
  fsLatHi               = $05AC;
  fsLonLo               = $05B0;
  fsLonHi               = $05B4;
  fsAltLo               = $05B8;
  fsAltHi               = $05BC;
  fsPitch               = $05C0;
  fsBank                = $05C4;
  fsHeading             = $05C8;
  fsMdlBaseName         = $065C;
  fsAPMasterSwitch      = $08F8;
  fsAPWingLeveler       = $08FC;
  fsAPNav1Hold          = $0900;
  fsAPHeadingHold       = $0904;
  fsAPHeading           = $0908;
  fsAPAlititudeHold     = $090C;
  fsAPAltitude          = $0910;
  fsAPAttitudeHold      = $0914;
  fsAPGlideSlopeHold    = $0918;
  fsAPLocalizerHold     = $091C;
  fsAPBackCourseHold    = $0920;
  fsAPYawDamper         = $0924;
  fsRPM                 = $09A8;
  fsFuelLeftPercent     = $0B68;
  fsFuelLeftCapGal      = $0B6C;
  fsFuelLeftAuxPercent  = $0B70;
  fsFuelLeftAuxCapGal   = $0B74;
  fsFuelRightPercent    = $0B80;
  fsFuelRightCapGal     = $0B84;
  fsFuelRightAuxPercent = $0B88;
  fsFuelRightAuxCapGal  = $0B8C;
  fsFlaps               = $0BBA;
  fsGear1               = $0BC0;
  fsGear2               = $0BC2;
  fsGear3               = $0BC4;
  fsGear1Timer          = $0BC6;
  fsGear2Timer          = $0BC8;
  fsGear3Timer          = $0BCA;
  fsTimeRate            = $0BE6;
  fsViewFlags           = $0D10;
  fsCloud2Ceiling       = $0EE8;
  fsCloud2Floor         = $0EEA;
  fsCloud2Coverage      = $0EEC;
  fsCloud2Deviation     = $0EEE;
  fsCloud1Ceiling       = $0EF0;
  fsCloud1Floor         = $0EF2;
  fsCloud1Coverage      = $0EF4;
  fsCloud1Deviation     = $0EF6;
  fsTStormCeiling       = $0EF8;
  fsTStormFloor         = $0EFA;
  fsTStormCoverage      = $0EFC;
  fsTStormDeviation     = $0EFE;
  fsTemp3Ceiling        = $0F00;
  fsTemp3Temp           = $0F02;
  fsTemp2Ceiling        = $0F04;
  fsTemp2Temp           = $0F06;
  fsTemp1Ceiling        = $0F08;
  fsTemp1Temp           = $0F0A;
  fsTemp0Ceiling        = $0F0C;
  fsTemp0Temp           = $0F0E;
  fsDayNightDrift       = $0F10;
  fsDayNightVariation   = $0F12;
  fsBarometricPressure  = $0F14;
  fsBarometricDrift     = $0F16;
  fsWind3Ceiling        = $0F18;
  fsWind3Floor          = $0F1A;
  fsWind3Speed          = $0F1C;
  fsWind3Direction      = $0F1E;
  fsWind3Turbulence     = $0F20;
  fsWind3GustySteady    = $0F22;
  fsWind2Ceiling        = $0F24;
  fsWind2Floor          = $0F26;
  fsWind2Speed          = $0F28;
  fsWind2Direction      = $0F2A;
  fsWind2Turbulence     = $0F2C;
  fsWind2GustySteady    = $0F2E;
  fsWind1Ceiling        = $0F30;
  fsWind1Floor          = $0F32;
  fsWind1Speed          = $0F34;
  fsWind1Direction      = $0F36;
  fsWind1Turbulence     = $0F38;
  fsWind1GustySteady    = $0F3A;
  fsWind0Ceiling        = $0F3C;
  fsWind0Speed          = $0F3E;
  fsWind0Direction      = $0F40;
  fsWind0Turbulence     = $0F42;
  fsWind0GustySteady    = $0F44;
  fsCloud2Type          = $0F46;
  fsCloud2Icing         = $0F48;
  fsCloud2Turbulence    = $0F4A;
  fsCloud1Type          = $0F4C;
  fsCloud1Icing         = $0F4E;
  fsCloud1Turbulence    = $0F50;
  fsTStormsType         = $0F52;
  fsTStormsIcing        = $0F54;
  fsTStormsTurbulence   = $0F56;
  fsVisibility          = $0F58;
  fsW0Speed             = $0F3E;
  fsW0Dir               = $0F40;
  fsW0Turb              = $0F42;
  fsTimeOfDay           = $113E;
  fsDynAirTraffic1      = $114C;
  fsDynGroundTraffic1   = $114E;
  fsDynServiceTraffic1  = $1150;
  fsDynOutsideTraffic1  = $1152;
  fsDynFreq1            = $1154;
  fsDynAirTraffic2      = $1156;
  fsDynGroundTraffic2   = $1158;
  fsDynServiceTraffic2  = $115A;
  fsDynOutsideTraffic2  = $115C;
  fsDynFreq2            = $115E;
  fsTextureFlag         = $1622;
  fsEngineOn            = $1624;
  fsAileron             = $162C;
  fsElevator            = $162E;
  fsRudder              = $1630;
  fsMdlState            = $1688;
  fsWheelSmoke          = $16AA;
  fsVersion             = $176C;


//--------------------------------------------------------------------------//
// by Jason Grooms.

Type tFS6StateData = record
    Unknown01   : array[$0000..$0237] of byte; // Unknown data area

    byClockHour : Byte;                        // +0238
    byBlockMin  : Byte;                        // +0239
    byClockSec  : Byte;                        // +023A

    Unknown02   : array[$023B..$0267] of byte; // Unknown data area

    dwPauseFlag : dword;                      // +0268 set to 1 when paused, 0 when not

    Unknown03   : array[$026C..$0287] of byte; // Unknown data area

    byLightsOn  : byte;                        // +0288
    byStrobeOn  : byte;                        // +0289
    byStrobeTimer : byte;                      // +028A

    Unknown04   : array[$028B..$0297] of byte; // Unknown data area

    byLandingLightOn : byte;                   // +0298

    Unknown05   : array[$0299..$029D] of byte; // Unknown data area

    wSpoiler    : word;                        // +029E 0: retracted; 7FFF: extended
    wMagVar     : word;                        // +02A0

    Unknown06   : array[$02A2..$02A7] of byte;  // Unknown data area

    wTickCount  : word;                        // +02A8 count of 55 msec ticks since FS6 started
    wFrameTime  : word;                        // +02AA frame time interval (time = x/8000h seconds)

    Unknown07   : array[$02AC..$02B3] of byte; // Unknown data area;

    dwTAS       : dword;                       // +02B4 true airspeed (m/s * 256)
    dwIAS       : dword;                       // +02B8 indicated airspeed (m/s * 256)

    Unknown08   : array[$02BC..$0355] of byte; // Unknown data area

    wBcdAdfFreq  : word;                       // +0356
    wBcdCom1Freq : word;                       // +0358
    wBcdNav1Freq : word;                       // +035A
    wBcdNav2Freq : word;                       // +035C
    wBcdXpdrCode : word;                       // +035E

    Unknown09 : array[$0360..$05A7] of byte;   // Unknown data area

    dwLatLo : dword;                           // +05A8 latitude (low dword)
    dwLatHi : dword;                           // +05AC latitude (high dword)
    dwLonLo : dword;                           // +05B0 longitude (low dword)
    dwLonHi : dword;                           // +05B4 longitude (high dword)
    dwAltLo : dword;                           // +05B8 Altitude (low dword)
    dwAltHi : dword;                           // +05Bc Altitude (high dword)
    dwPitch : dword;                           // +05C0 Pitch
    dwBank  : dword;                           // +05C4 Bank
    dwHeading : dword;                         // +05C8 Heading

    Unknown10 : array[$05CC..$065B] of byte;   // Unknown data area

    szMdlBaseName : array[0..255] of char;     // Aircraft MDL base filename

    Unknown11 : array[$075C..$08F7] of byte;   // Unknown data area

    dwAPMaster : dword;                        // +08F8 autopilot master switch (0 or 1)
    dwAPWingLeveler : dword;                   // +08FC autopilot wing leveler enable (0 or 1)
    dwAPNav1Hold : dword;                      // +0900 autopilot Nav1 hold enable (0 or 1)
    dwAPHeadingHold : dword;                   // +0904 autopilot heading hold (0 or 1)
    dwAPHeading : dword;                       // +0908 autopilot heading to hold (actual heading * 0x10000/360.0)
    dwAPAltitudeHold : dword;                  // +090C autopilot altitude hold enable (0 or 1)
    dwAPAltitude : dword;                      // +0910 autopilot altitude to hold (actual altitude in meters * 0x10000)
    dwAPAttitudeHold : dword;                  // +0914 autopilot attitude (pitch & bank) hold enable (0 or 1)
    dwAPGlideSlopeHold : dword;                // +0918 autopilot glide slope hold enable (0 or 1)
    dwAPLocalizerHold : dword;                 // +091c autopilot localizer hold enable (0 or 1)
    dwAPBackCourseHold : dword;                // +0920 autopilot back course hold enable (0 or 1)
    dwAPYawDamper : dword;                     // +0924 autopilot yaw damper enable (0 or 1)

    Unknown12 : array[$0928..$09A7] of byte;   // Unknown Data Area

    wRPM : word;                               // +09A8

    Unknown13 : array[$09AA..$0B67] of byte;   // Unknown data area

    dwFuelLeftPct : dword;                     // +0B68  left fuel tank quantity (%)
    dwFuelLeftCapGal : dword;                  // +0B6C  left fuel tank capacity (gallons)
    dwFuelLeftAuxPct : dword;                  // +0B70  left aux fuel tank quantity (%)
    dwFuelLeftAuxCapGal : dword;               // +0B74  left aux fuel tank capacity (gallons)

    Unknown14 : array[$0B78..$0B7F] of byte;   // Unknown data area

    dwFuelRightPct : dword;                    // +0B80  right fuel tank quantity (%)
    dwFuelRightCapGal : dword;                 // +0B84  right fuel tank capacity (gallons)
    dwFuelRightAuxPct : dword;                 // +0B88  right aux fuel tank quantity (%)
    dwFuelRightAuxCapGal : dword;              // +0B8C  right aux fuel tank capacity (gallons)

    Unknown15 : array[$0B90..$0BB9] of byte;   // Unknown data area

    wFlaps : word;                             // +0BBA  0: retracted; 7FFF: extended

    Unknown16 : array[$0BBC..$0BBF] of byte;   // Unknown data area

    wGear1 : word;                             // +0BC0  gear position (0=up, FFFF=down)
    wGear2 : word;                             // +0BC2
    wGear3 : word;                             // +0BC4

    wGear1Timer : word;                        // +0BC6  gear position (0=up, 7FFF=down)
    wGear2Timer : word;                        // +0BC8
    wGear3Timer : word;                        // +0BCA

    Unknown17 : array[$0BCC..$0BE5] of byte;   // Unknown data area

    wTimeRate : word;                          // +0BE6  time rate (1.0 == 0100h)

    Unknown18 : array[$0BE8..$0D0F] of byte;   // Unknown data area

    dwViewFlags : dword;                       // +0D10

    Unknown19 : array[$0D14..$0EE7] of byte;   // Unknown data area

    wCloud2Ceiling : word;                     // +0EE8  (meters)
    wCloud2Floor : word;                       // +0EEA  (meters)
    wCloud2Coverage : word;                    // +0EEC
    wCloud2Deviation : word;                   // +0EEE  (meters)

    wCloud1Ceiling : word;                     // +0EF0  (meters)
    wCloud1Floor : word;                       // +0EF2  (meters)
    wCloud1Coverage : word;                    // +0EF4
    wCloud1Deviation : word;                   // +0EF6  (meters)

    wTStormCeiling : word;                     // +0EF8  (meters)
    wTStormFloor : word;                       // +0EFA  (meters)
    wTStormCoverage : word;                    // +0EFC
    wTStormDeviation : word;                   // +0EFE  (meters)

    wTemp3Ceiling : word;                      // +0F00  (meters)
    sTemp3Temp : short;                        // +0F02  (In Celsius)

    wTemp2Ceiling : word;                      // +0F04  (meters)
    sTemp2Temp : short;                        // +0F06  (celsius)

    wTemp1Ceiling : word;                      // +0F08  (meters)
    sTemp1Temp : short;                        // +0F0A  (celsius)

    wTemp0Ceiling : word;                      // +0F0C  (meters)
    sTemp0Temp : short;                        // +0F0E  (celsius)

    wDayNightDrift : word;                     // +0F10
    wDayNightVariation : word;                 // +0F12

    wBarometricPressure : word;                // +0F14
    wBarometricDrift : word;                   // +0F16

    wWind3Ceiling : word;                      // +0F18  (meters)
    wWind3Floor : word;                        // +0F1A  (meters)
    wWind3Speed : word;                        // +0F1C
    wWind3Direction : word;                    // +0F1E
    wWind3Turbulence : word;                   // +0F20
    wWind3GustySteady : word;                  // +0F22

    wWind2Ceiling : word;                      // +0F24  (meters)
    wWind2Floor : word;                        // +0F26  (meters)
    wWind2Speed : word;                        // +0F28
    wWind2Direction : word;                    // +0F2A
    wWind2Turbulence : word;                   // +0F2C
    wWind2GustySteady : word;                  // +0F2E

    wWind1Ceiling : word;                      // +0F30  (meters)
    wWind1Floor : word;                        // +0F32  (meters)
    wWind1Speed : word;                        // +0F34
    wWind1Direction : word;                    // +0F36
    wWind1Turbulence : word;                   // +0F38
    wWind1GustySteady : word;                  // +0F3A

    wWind0Ceiling : word;                      // +0F3C  (meters)
    wWind0Speed : word;                        // +0F4E
    wWind0Direction   : word;                  // +0F40
    wWind0Turbulence   : word;                 // +0F42
    wWind0GustySteady : word;                  // +0F44

    wCloud2Type : word;                        // +0F46
    wCloud2Icing : word;                       // +0F48
    wCloud2Turbulence : word;                  // +0F4A
    wCloud1Type : word;                        // +0F4C
    wCloud1Icing : word;                       // +0F4E
    wCloud1Turbulence : word;                  // +0F50
    wTStormsType : word;                       // +0F52
    wTStormsIcing : word;                      // +0F54
    wTStormsTurbulence : word;                 // +0F56

    wVisibility : word;                        // +0F58

    Unknown20 : array[$0F5A..$113D] of byte;   // Unknown data area

    wTimeOfDay : word;                         // +113E

    Unknown21 : array[$1140..$114B] of byte;   // Unknown data area

    wDynAirTraffic1 : word;                    // +114C
    wDynGroundTraffic1 : word;                 // +114E
    wDynServiceTraffic1 : word;                // +1150
    wDynOutsideTraffic1 : word;                // +1152
    wDynFrequency1 : word;                     // +1154
    wDynAirTraffic2 : word;                    // +1156 dynamic scenery (view window 2)
    wDynGroundTraffic2 : word;                 // +1158
    wDynServiceTraffic2 : word;                // +115A
    wDynOutsideTraffic2 : word;                // +115C
    wDynFrequency2 : word;                     // +115E

    Unknown22 : array[$1160..$1621] of byte;   // Unknown data area

    wTextureFlag : word;                       // +1622
    wEngineOn : word;                          // +1624

    Unknown23 : array[$1626..$162B] of byte;   // Unknown data area

    wAileron : word;                           // +162C
    wElevator : word;                          // +162E
    wRudder : word;                            // +1630

    Unknown24 : array[$1632..$1687] of byte;   // Unknown data area

    wMdlState : pointer;                       // +1688

    Unknown25 : array[$168C..$16A9] of byte;   // Unknown data area

    wWheelSmoke : word;                        // + 16AA

    Unknown26 : array[$16AC..$176B] of byte;   // Unknown data area

    wFSVersion : word;                         // +176C
End;

//--------------------------------------------------------------------------//
// by A. Antonini
Type tFS98StateData = Record
    UnkNown01       : Array[$0..$237] Of Byte;
    byClockHour     : Byte;                         // +0238
    byClockMin      : Byte;                         // +0239
    byClockSec      : Byte;                         // +023A
    Unknown02       : Array[$23B..$267] Of Byte;    
    dwPauseFlag     : DWORD;                        // +0268 set to 1 when  
                                                    //  paused,0 when not
    Unknown03       : Array[$23B..$27F] Of Byte;
    byLightsOn,                                     // +0280
    byStrobeOn,                                     // +0281
    byStrobeTimer   : Byte;                         // +0282
    Unknown04       : Array[$283..$28B] Of Byte;

    Union1 : Record 
        Case Integer Of
            0: (dwLandingLightOn : DWORD); // +028C  
            1: (byLandingLightOn : Byte);  // +028C  FS6State compatability
        End;

    Unknown05               : Array[$290..$29D] Of Byte;
    wSpoiler                : WORD;      // +029E  0: retracted; 7FFF: extended
    wMagVar                 : WORD;      // +02A0
    Unknown06               : Array[$2A2..$2B7] Of Byte;

    dwTAS                   : DWORD;     // +02B8  true airspeed (m/s * 256)
    Unknown07               : Array[$2BC..$34B] Of Byte;
    wBcdAdfFreq             : WORD;      // +034C
    wBcdCom1Freq            : WORD;      // +034E
    wBcdNav1Freq            : WORD;      // +0350
    wBcdNav2Freq            : WORD;      // +0352
    wBcdXpdrCode            : WORD;      // +0354
    Unknown08               : Array[$356..$445] Of Byte;
    szVisBaseName           : Array[1..256] Of Char; //+0446 VIS base file name (JF Vole)
    Unknown09               : Array[$546..$55F] Of Byte;
    dwLatLo                 : DWORD;    // +0560 latitude  (low dword)
    dwLatHi                 : DWORD;    // +0564 latitude  (high dword)
    dwLonLo                 : DWORD;    // +0568 longitude (low dword)
    dwLonHi                 : DWORD;    // +056C longitude (high dword)
    dwAltLo                 : DWORD;    // +0570 altitude  (low dword)
    dwAltHi                 : DWORD;    // +0574 altitude  (high dword)
    dwPitch                 : DWORD;    // +0578 pitch
    dwBank                  : DWORD;    // +057C bank
    dwHeading               : DWORD;    // +0580 heading
    Unknown10               : Array[$584..$7BB] Of Byte;
    dwAPMaster              : DWORD; // +07BC autopilot master switch (0 or 1)
    dwAPWingLeveler         : DWORD; // +07C0 autopilot wing leveler enable (0 or 1)
    dwAPNav1Hold            : DWORD; // +07C4 autopilot Nav1 hold enable (0 or 1)
    dwAPHeadingHold         : DWORD; // +07C8 autopilot heading hold enable (0 or 1)
    dwAPHeading             : DWORD; // +07CC autopilot heading to hold (actual heading * 0x10000/360.0)
    dwAPAltitudeHold        : DWORD; // +07D0 autopilot altitude hold enable (0 or 1)
    dwAPAltitude            : DWORD; // +07D4 autopilot altitude to hold (actual altitude in meters * 0x10000)
    dwAPAttitudeHold        : DWORD; // +07D8 autopilot attitude (pitch & bank) hold enable (0 or 1)
    dwAPAirSpeedHold        : DWORD; // +07DC autopilot air speed hold enable (0 or 1)
    Unknown11               : Array[$7E0..$7E1] Of Byte;
    wAPAirSpeed             : Word;  // +07E2 autopilot air speed to hold
    dwAPMachNumberHold      : DWORD; // +07E4 autopilot Mach number 
    dwAPMachNumber          : DWORD; // +07E8 autopilot Mach number to hold 
    Unknown12               : Array[$7EC..$7F1] Of Byte;
    wAPVerticalSpeed        : Word;  // +07F2 autopilot vertical speed
    Unknown13               : Array[$7F4..$7FB] Of Byte;
    dwAPGlideSlopeHold,              // +07FC autopilot glide slope hold
    dwAPLocalizerHold,               // +0800 autopilot localizer hold 
    dwAPBackCourseHold,              // +0804 autopilot back course hold
    dwAPYawDamper,                   // +0808 autopilot yaw damper enable
    dwAPToGa,                        // +080C autopilot take-off/go-around
    dwAPAutoThrottle        : Dword; // +0810 autopilot auto throttle 
    Unknown14               : Array[$814..$BE7] Of Byte;
    rGear : Record 
        Case Integer Of
            0: (dwGear   : DWORD);       // +0BE8  gear position (0=up, 3FFF=down
            1: (wGear1   : Word);        // +0BE8  FS6State compatibility
            2: (wGear2   : Word);        // +0BE8  FS6State compatibility
            3: (wGear3   : Word);        // +0BE8  FS6State compatibility
        End;
    rGear1Timer : Record 
        Case Integer Of
            0: (dwGear1Timer : DWORD);    // +0BEC  gear 1 timer (0=up, 3FFF=down)
            1: (wGear1Timer  : WORD);     // +0BEC  FS6State compatibility
        End;
    rGear2Timer : Record 
        Case Integer Of
            0: (dwGear2Timer : DWORD);    // +0BF0  gear 2 timer                  
            1: (wGear2Timer  : WORD);     // +0BF0  FS6State compatibility    
        End;
    rGear3Timer : Record 
        Case Integer Of
            0: (dwGear3Timer : DWORD);    // +0BF4  gear 3 timer                  
            1: (wGear3Timer  : WORD);     // +0BF4  FS6State compatibility    
        End;
    Unknown15               : Array[$BF8..$D47] Of Byte;
    dwViewFlags             : DWORD; // +0D48
    Unknown16               : Array[$D4C..$F1B] Of Byte;
    wCloud2Ceiling,                  // +0F1C  (meters)              
    wCloud2Floor,                    // +0F1E  (meters)              
    wCloud2Coverage,                 // +0F20                        
    wCloud2Deviation,                // +0F22  (meters)              
    wCloud1Ceiling,                  // +0F24  (meters)              
    wCloud1Floor,                    // +0F26  (meters)              
    wCloud1Coverage,                 // +0F28                        
    wCloud1Deviation,                // +0F2A  (meters)              
    wTStormCeiling,                  // +0F2C  (meters)              
    wTStormFloor,                    // +0F2E  (meters)              
    wTStormCoverage,                 // +0F30                        
    wTStormDeviation,                // +0F32  (meters)              
    wTemp3Ceiling,                   // +0F34  (meters)              
    wTemp3Temp,                      // +0F36  (celsius * 256)       
    wTemp2Ceiling,                   // +0F38  (meters)              
    wTemp2Temp,                      // +0F3A  (celsius * 256)       
    wTemp1Ceiling,                   // +0F3C  (meters)              
    wTemp1Temp,                      // +0F3E  (celsius * 256)       
    wTemp0Ceiling,                   // +0F40  (meters)              
    wTemp0Temp,                      // +0F42  (celsius * 256)       
    wDayNightDrift,                  // +0F44                        
    wDayNightVariation,              // +0F46                        
    wBarometricPressure,             // +0F48                        
    wBarometricDrift,                // +0F4A                        
    wWind3Ceiling,                   // +0F4C  (meters)              
    wWind3Floor,                     // +0F4E  (meters)              
    wWind3Speed,                     // +0F50                        
    wWind3Direction,                 // +0F52                        
    wWind3Turbulence,                // +0F54                        
    wWind3GustySteady,               // +0F56                        
    wWind2Ceiling,                   // +0F58  (meters)              
    wWind2Floor,                     // +0F5A  (meters)              
    wWind2Speed,                     // +0F5C                        
    wWind2Direction,                 // +0F5E                        
    wWind2Turbulence,                // +0F60                        
    wWind2GustySteady,               // +0F62                        
    wWind1Ceiling,                   // +0F64  (meters)              
    wWind1Floor,                     // +0F66  (meters)              
    wWind1Speed,                     // +0F68                        
    wWind1Direction,                 // +0F6A                        
    wWind1Turbulence,                // +0F6C                        
    wWind1GustySteady,               // +0F6E                        
    wWind0Ceiling           : Word;  // +0F70  (meters)              
    wWind0Speed             : Word;  // +0F72
    wWind0Direction         : Word;  // +0F74
    wWind0Turbulence        : Word;  // +0F76
    wWind0GustySteady,               // +0F78
    wCloud2Type,                     // +0F7A 
    wCloud2Icing,                    // +0F7C 
    wCloud2Turbulence,               // +0F7E 
    wCloud1Type,                     // +0F80 
    wCloud1Icing,                    // +0F82 
    wCloud1Turbulence,               // +0F84 
    wTStormsType,                    // +0F86 
    wTStormsIcing,                   // +0F88 
    wTStormsTurbulence,              // +0F8A 
    wVisibility             : Word;  // +0F8C
    Unknown001              : Array[$F8E..$1FFF] Of Byte;
End;

//--------------------------------------------------------------------------//
Const LatInt2Lat    : Extended = 8.99842527557677E-0006; // 45/5000875
      LonInt2Lon    : Extended = 8.38190317153931E-0008; // 90/(256*4194304);


type
    tNav = ( Nav1, Nav2 );
    FS6IPC_Client = class
    public
    { Ported Functions }
        Constructor Init;
        function  Start(hWndFs6 : hwnd; dwBufSize : dword; dwTimeout : dword) : boolean;
        procedure Stop;
        function  BeginRequest : BOOL;
        function  ReadStateData(dwStateTableOffset : dword; nBytes : dword; pDest : pointer) : boolean;
        function  WriteStateData(dwStateTableOffset : dword; nBytes: dword; pSrc : pointer) : boolean;
        function  SendRequest : boolean;

        { Utility functions }
        function GetAircraftPosition(var Lat : Extended;
                                           var Lon : Extended ;
                                           var Alt : Extended;
                                           var IAS : Extended) : boolean;
        function GetXPnderCode(var code : shortstring) : boolean;
        function GetCOM1Freq(var freq : shortstring) : boolean;
        function GetNAVFreq(var freq : shortstring; Nav: tNav) : boolean;

    protected
    end;

Var
    // NOTE D3 crash if we try to protect them ( ???? )
        m_id        : dword;               // instance identifier
        m_hWnd      : hwnd;                // FS6 window handle
        m_dwTimeout : dword;               // message timeout in milliseconds
        m_msg       : uint;                // id of registered window message
        m_atom      : atom;                // global atom containing name of file-mapping object
        m_hMap      : thandle;             // handle of file-mapping object
        m_pView     : pointer;             // pointer to view of file-mapping object
        m_pNext     : pointer;             // pointer to next available byte in view
        m_idNext    : dword;               // next instance identifier


Var FS6StateData : tFs6StateData;
Var FS98StateData : tFs98StateData;

//--------------------------------------------------------------------------//
Implementation

//--------------------------------------------------------------------------//
Uses SysUtils;

Constructor FS6IPC_CLIENT.Init;

begin
    m_id := 0;
    m_dwTimeout := 2000;
    m_hWnd := 0;
    m_msg := 0;
    m_atom := 0;
    m_hMap := 0;
    m_pView := nil;
    m_pNext := nil;
    m_idNext := 0;
end;


function FS6IPC_CLIENT.Start(hWndFs6 : hwnd; dwBufSize : dword; dwTimeout : dword) : boolean;

var szName : AnsiString;
begin
{ This is a straight port of the C code.  I don't approved of the multiple exits within }
{ one function but that is the way C programmers like to program.                       }
// and it's the way to do it under C :-)

  // abort if already started
  if (m_pView <> nil) then
    begin
      Result := False;
      Exit;
    end;

  m_hWnd := hWndFs6;
  m_dwTimeout := dwTimeout;
  Inc(m_idNext);
  m_id := m_idNext;

  // register the window message
  m_msg := RegisterWindowMessage(FS6IPC_MESSAGENAME);
  if (m_msg = NULL) then
    begin
      Result := False;
      Exit;
    end;

  // create the name of our file-mapping object
    szName:=Format('%s:%X:%X', [FS6IPC_MESSAGENAME,GetCurrentProcessId,m_id]);

  // stuff the name into a global atom
  m_atom := GlobalAddAtom(Pchar(szName));
  if (m_atom = NULL) then
    begin
      Stop;
      Result := False;
      Exit;
    end;


  // create the file-mapping object
  m_hMap := CreateFileMapping(
    tHandle($FFFFFFFF),   // use system paging file
    Nil,                  // security
    PAGE_READWRITE,       // protection
    0, dwBufSize,         // size
    Pchar(szName));       // name

  if ((m_hMap = NULL) or (GetLastError = ERROR_ALREADY_EXISTS)) then
    begin
      Stop;
      Result := False;
      Exit;
    end;


  // get a view of the file-mapping object
  m_pView := MapViewOfFile(m_hMap, FILE_MAP_WRITE, 0, 0, 0);
  if (m_pView = nil) then
    begin
      Stop;
      Result := False;
      Exit;
    end;

  m_pNext := m_pView;

  Result := TRUE;
end;

procedure FS6IPC_CLIENT.Stop;
begin
  m_hWnd := 0;
  m_msg := 0;
  m_pNext := nil;

  if (m_atom <> NULL) then
    begin
      GlobalDeleteAtom(m_atom);
      m_atom := 0;
    end;

  if (m_pView <> nil) then
    begin
      UnmapViewOfFile(m_pView);
      m_pView := nil;
    end;

  if (m_hMap <> NULL) then
    begin
      CloseHandle(m_hMap);
      m_hMap := 0;
    end;

end;


function FS6IPC_CLIENT.BeginRequest : BOOL;
begin
  if (m_pView = nil) then
    begin
      Result := False;
      Exit;
    end;

  m_pNext := m_pView;

  Result := True;
end;

function FS6IPC_CLIENT.ReadStateData(dwStateTableOffset : dword; nBytes : dword; pDest : pointer) : boolean;
var
  pHdr : ^FS6IPC_READSTATEDATA_HDR;
begin
  Result := True;
  if (m_pView <> nil) then
    begin
      // fill the header
      pHdr := m_pNext;
      pHdr^.dwId := FS6IPC_READSTATEDATA_ID;
      pHdr^.dwOffset := dwStateTableOffset;
      pHdr^.nBytes := nBytes;
      pHdr^.pDest := pDest;
      // advance the pointer and leave room for the returned data
      dword(m_pNext) := dword(m_pNext)+ sizeof(FS6IPC_READSTATEDATA_HDR) + nBytes;
    end
  else
    Result := False;
end;

function FS6IPC_CLIENT.WriteStateData(dwStateTableOffset : dword; nBytes: dword; pSrc : pointer) : boolean;
var
  pHdr : ^FS6IPC_WRITESTATEDATA_HDR;
begin
  Result := True;
  if (m_pView <> nil) then
    begin
      // fill the header
      pHdr := m_pNext;
      pHdr^.dwId := FS6IPC_WRITESTATEDATA_ID;
      pHdr^.dwOffset := dwStateTableOffset;
      pHdr^.nBytes := nBytes;

      // advance the pointer
      dword(m_pNext) := dword(m_pNext) + sizeof(FS6IPC_WRITESTATEDATA_HDR);

      // copy the data
      CopyMemory(m_pNext, pSrc, nBytes);

      // advance the pointer
      dword(m_pNext) := dword(m_pNext) + nBytes;
    end
  else
    Result := False;
end;

function FS6IPC_CLIENT.SendRequest : boolean;
var
  dwResult : dword;
  reqid    : dword;
  pHdr     : ^FS6IPC_READSTATEDATA_HDR;
begin
  if (m_pView = nil) then
    begin
      Result := False;
      Exit;
    end;

  // terminate the request buffer
  DWORD(m_pNext^) := 0;

  // send the request
  if  (NOT Boolean(SendMessageTimeout(
    m_hWnd,
    m_msg,
    m_atom,
    0,
    SMTO_BLOCK,
    m_dwTimeout,
    dwResult))) then

    begin
      Result := False;
      Exit;
    end;

  // process the completed request
  m_pNext := m_pView;

  reqid := dword(m_pNext^);
  while (reqid <> 0) do
    begin
      case (reqid) of
          FS6IPC_READSTATEDATA_ID:
            begin
              // copy the data we read into the user's buffer
              pHdr := m_pNext;
              dword(m_pNext) := dword(m_pnext) + sizeof(FS6IPC_READSTATEDATA_HDR);
              CopyMemory(pHdr^.pDest, m_pNext, pHdr^.nBytes);
              dword(m_pNext) := dword(m_pNext) + pHdr^.nBytes;
            end;

          FS6IPC_WRITESTATEDATA_ID:
            begin
              // don't need to do anything but skip over the request
              pHdr := m_pNext;
              dword(m_pNext) := dword(m_pNext) + sizeof(FS6IPC_WRITESTATEDATA_HDR) + pHdr^.nBytes;
            end;

      else
        begin
          // error??
          m_pNext := m_pView;
          Result := False;
          Exit;
        end;
      end;
      reqid := dword(m_pNext^);
    end;

  m_pNext := m_pView;
  Result := (dwResult = FS6IPC_MESSAGE_SUCCESS);

end;

{ =========================================================================================== }
{ The code that follows was added by me.  It can be deleted if so desired                     }
{ =========================================================================================== }
function FS6IPC_CLIENT.GetAircraftPosition(var Lat : Extended; 
                                           var Lon : Extended ; 
                                           var Alt : Extended;
                                           var IAS : Extended) : boolean;

type
 tflightdata = record
    dwLatLo     : dword;
    dwLatHi     : dword;
    dwLonLo     : dword;
    dwLonHi     : dword;
    dwAltLo     : dword;
    dwAltHi     : dword;
    dwIAS       : dword;
  end; { tflightdata }

var flightdata : tflightData;
    intPart : integer;
   // mps : Extended;

begin
    BeginRequest;
    // request to read the position and orientation of the aircraft
    ReadStateData(fsLatLo, 6 * sizeof(flightdata.dwLatLo), 
                           @flightdata.dwLatLo);
    ReadStateData(fsIAS, sizeof(flightdata.dwIAS), @flightdata.dwIAS);

    // send the data request
    if (NOT SendRequest) then begin
        Result := False;
        Exit;
    end;

    IAS := (flightdata.dwIAS/256)*1.997;

    // Adjust latitude
    intPart := flightData.dwLatHi;
    if (intPart >= 0) then
        lat := intPart + flightdata.dwLatLo / 68719476736.0
    else lat := intPart - flightData.dwLatLo / 68719476736.0;

    lat := lat * Latint2lat; // * 45.0 / 5000875.0;


   // Adjust Longitude
   intPart := flightdata.dwLonHi;
   if (intPart >= 0) then
     lon := intPart + flightdata.dwLonLo / 68719476736.0
   else
        lon := intPart - flightdata.dwLonLo / 68719476736.0;

        lon := lon * LonInt2Lon; //  lon * 90.0 / (256.0 * 4194304.0);

        if lon > 180 then lon := lon -360;


   // adjust altitude
   alt := int((flightdata.dwAltHi + flightdata.dwAltLo / 68719476736.0)* 3.281);

   Result := True;
end;

function FS6IPC_Client.GetXpnderCode(var code : shortstring) : boolean;
var dwCode : dword;

begin
    BeginRequest;
    ReadStateData(fsXPNDRCode, sizeof(dwCode), @dwCode);

    if (SendRequest) then begin
        Code := IntToHex(dwCode, 4);
        Result := True;
    end
    else begin
        Code := '';
        Result := False;
    end;
end;

function FS6IPC_Client.GetCOM1Freq(var freq : shortstring) : boolean;

var dwFreq : word;

begin
    BeginRequest;
    ReadStateData(fsCOM1Freq, sizeof(dwFreq), @dwFreq);

    if (SendRequest) then begin
        Freq := '1'+IntToHex(dwFreq, 4)+'0';
        Insert('.',Freq,4);
        Result := True;
    end
    else begin
        Freq := '';
        Result := False;
    end;

end;

// slightly modified by Antonini, allows to choose which NAV to read
// with a Extended function
function FS6IPC_Client.GetNAVFreq(var freq : shortstring; Nav: tNav):boolean;

var dwFreq : word;

begin
    BeginRequest;
    Case Nav Of
        Nav1:  ReadStateData(fsNAV1Freq, sizeof(dwFreq), @dwFreq);
        Nav2:  ReadStateData(fsNAV2Freq, sizeof(dwFreq), @dwFreq);
    End;

    if (SendRequest) then begin
        Freq := '1'+IntToHex(dwFreq, 4);
        Insert('.',Freq,4);
        Result := True;
    end 
    else begin
        Freq := '';
        Result := False;
    end;
end;

End.
