{$APPTYPE CONSOLE}
Program TestFs;

Uses Windows, Fs6State, IPCUtils, SysUtils;

          
Var FS98wnd,
    FS6wnd  : HWND;
    CurWin  : Hwnd;
    llat,
    llon    : ShortString;
    IpcFs6  : FS6IPC_Client;
    pFsInfo : fsInfo;
    Var i : Integer;
    d: Extended;

Begin
    CurWin:=0;
    IpcFs6:=Nil;

    FillChar(pFsInfo,SizeOf(pFsInfo),0);

    // first we init ipc class and set some default variables
    IPCFS6.Init;    

    // try to determine if one of both flight simulators are running
    FS6wnd  := FindWindowEx( 0, 0, pChar(FS95Info.pszWindowClass), Nil );

    FS98wnd := FindWindowEx( 0, 0, pChar(FS98Info.pszWindowClass), Nil );

    If FS6Wnd<>0 Then Begin
        pFsInfo:=fs95Info;
        CurWin:=FS6Wnd;
    End
    Else If FS98Wnd<>0 Then Begin
        pFsInfo:=fs98Info;
        CurWin:=FS98Wnd;
    End
    Else Begin
        WriteLn('Can''t find Flight Simulator. Have you started it yet?');
        Halt;
    End;
    IpcFs6.Start(CurWin,$10000,2000);

    For i:=1 to 20 Do Begin
        // get current lat/lon
        If IpcGetLat( IpcFs6, pfsInfo, llat, llon ) Then Begin
            WriteLn(lLat,'        ',lLon);
        End Else WriteLn('Unsuccessful');
        Sleep(1000);
    End;
    
    // test writing state data
    IpcFs6.BeginRequest;

    // lower the landing gear
    WriteLn('Lowering gear....');
    IpcFs6.WriteStateData(
            pFSInfo.offset_wGear1, sizeof(pFSInfo.wGearMask), 
            @pFSInfo.wGearMask);
    IpcFs6.WriteStateData(
            pFSInfo.offset_wGear2, sizeof(pFSInfo.wGearMask), 
            @pFSInfo.wGearMask);
    IpcFs6.WriteStateData(
            pFSInfo.offset_wGear3, sizeof(pFSInfo.wGearMask), 
            @pFSInfo.wGearMask);  

    IpcFs6.WriteStateData(
            pFSInfo.offset_wGear1, sizeof(pFSInfo.wGearMask), 
            @pFSInfo.wGearMask);

    // send the request
    ipcFS6.SendRequest;

    // try read some further data
    For i:=1 to 20 Do Begin
        // get current lat/lon
        If IpcGetAll( IpcFs6, pfsInfo ) Then Begin
            d:=   (flightdata.dwTas/256)*1.997;
            WriteLn((flightdata.dwTas/256)*1.997:0:0 ,'        ',
            dwHeading2Deg(flightdata.dwHeading):0:0 ,'        ',
                    FloatToStr(d));
        End Else WriteLn('Unsuccessful');
        Sleep(1000);
    End;
End.
