// movingMapMaster.pp
// modified by Marc Mooser    July 2000

{$APPTYPE CONSOLE}
Program TestFs;

//!! = changes by MM

Uses Windows, Fs6State, IPCUtils, SysUtils,
//!!
     Combase, WIN32COM, CRT;

Var FS98wnd,
    //FS6wnd  : HWND;
    CurWin  : Hwnd;
    llat,
    llon    : ShortString;
    IpcFs6  : FS6IPC_Client;
    pFsInfo : fsInfo;
    //Var i : Integer;
    //d: Extended;


//// by MM 

    ComObj                       : PCommObj;

    firstTime                    : int;
    
    alt, pause,                          
    heading, TAS                 : longint;       // True Air Speed

    C,                         
    chNS,chWE                    : Char;
    
    head_string, 
    tas_string, tas_str,
    alt_string,
    nmea_string, 
    lat_string, lon_string       : String;
                      


///// by Marc Mooser //////////////////////////////////////////////////////


Function char2int(ch : Char) : int;
Var res: int;
Begin
   res:=0;
   if(ch = '0') then res:=48; 
   if(ch = '1') then res:=49; 
   if(ch = '2') then res:=50; 
   if(ch = '3') then res:=51; 
   if(ch = '4') then res:=52; 
   if(ch = '5') then res:=53; 
   if(ch = '6') then res:=54; 
   if(ch = '7') then res:=55; 
   if(ch = '8') then res:=56; 
   if(ch = '9') then res:=57; 

   if(ch = 'A') then res:=65; 
   if(ch = 'B') then res:=66; 
   if(ch = 'C') then res:=67; 
   if(ch = 'D') then res:=68; 
   if(ch = 'E') then res:=69; 
   if(ch = 'F') then res:=70; 
   if(ch = 'G') then res:=71; 
   if(ch = 'H') then res:=72; 
   if(ch = 'I') then res:=73; 
   if(ch = 'J') then res:=74; 
   if(ch = 'K') then res:=75; 
   if(ch = 'L') then res:=76; 
   if(ch = 'M') then res:=77; 
   if(ch = 'N') then res:=78; 
   if(ch = 'O') then res:=79; 
   if(ch = 'P') then res:=80; 
   if(ch = 'Q') then res:=81; 
   if(ch = 'R') then res:=82; 
   if(ch = 'S') then res:=83; 
   if(ch = 'T') then res:=84; 
   if(ch = 'U') then res:=85; 
   if(ch = 'V') then res:=86; 
   if(ch = 'W') then res:=87; 
   if(ch = 'X') then res:=88; 
   if(ch = 'Y') then res:=89; 
   if(ch = 'Z') then res:=90; 

   if(ch = '.') then res:=46; 
   if(ch = ',') then res:=44; 

   Result:=res;
End;




///// by Marc Mooser ///////////////////////////////////////////////////////////////////




Function checksum( wholeString : String ): String;         

Var 
    str_len, i, res     : longint;
    
Begin
    i:=2;
    str_len := Length( wholeString ); 

    res := char2int(wholeString[i]);
    repeat
       i:=i+1;                
       res := res xor char2int(wholeString[i]); 
    until i=str_len;

    Result := IntToHex( res,2 );
End; 




///////////////////////////////////////////////////////////////////////////////////

Begin
    CurWin:=0;
    IpcFs6:=Nil;
    FillChar(pFsInfo,SizeOf(pFsInfo),0);
    // first we init ipc class and set some default variables
    IPCFS6.Init; 
//!!
    FS98wnd := FindWindowEx( 0, 0, 'FS98MAIN', Nil );
//!!try to determine if one of both flight simulators are running
    pFsInfo:=fs98Info;
    CurWin:=FS98Wnd;
    IpcFs6.Start(CurWin,$10000,2000);

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//// by Marc Mooser //////////////////////////////////////////////////////////////////////////////////////!!
 
    ComObj := New(PWin32Obj, Init);
    ComObj^.DontClose := true;                { We use an inherited handle, never close it! }
    ComObj^.Com_Open(1,4800,8,'N',1);  
    //ComObj^.Com_OpenQuick(ComHandle);       { Open the comport using the handle }

    Writeln('');
    Writeln('--------------------------------------------------------------------');
    Writeln('MovingMapMaster ver 0.2  by Marc Mooser July 2000    exit with [Esc]');
    Writeln('--------------------------------------------------------------------');
    Writeln('');
    Writeln('  Altitude         Latitude             Longitude               True Air Speed');
    Writeln('   (meters)         (Breitengrad)         (Laengengrad)');
    Writeln('');

    If Not IpcGetLat( IpcFs6, pfsInfo, llat, llon, lat_string, lon_string ) Then Begin Writeln('Please start MS Flight Simulator first.'); Sleep(10000); Exit; End;
    If Not IpcGetAll( IpcFs6, pFsInfo, heading, TAS, alt, pause) Then Begin Writeln('Please start MS Flight Simulator first.'); Sleep(10000); Exit; End;

    firstTime := 1; 

    repeat
                if keypressed then C:=Readkey; 
 
                // ----------------------------------
                // Breiten(lat)- und Lngengrade(lon)
                // ----------------------------------
                if( llat[1] = '-' ) then begin chNS := 'S'; end
                else                     begin chNS := 'N'; end;
                if( llon[1] = '-' ) then begin chWE := 'W'; end
                else                     begin chWE := 'E'; end;

                // - bzw. + wegnehmen
                llat:=RightStr(llat, Length(llat)-1);                
                llon:=RightStr(llon, Length(llon)-1);
                
                // ---------------      
                // Heading und TAS (True Air Speed)
                // ---------------
                Str(Abs(dwHeading2Deg(heading)):0:1,head_string);
                Str(( (TAS/256)*1.997 ):0:1,tas_string);
                tas_str := tas_string; 
                if( (TAS/256)*1.997 < 10) then begin tas_string:='0'+tas_string; end;
                if( (TAS/256)*1.997 < 100) then begin tas_string:='0'+tas_string; end;
                   
                // --------
                // Altitude
                // --------
                alt_string := IntToStr(alt);
      
                // --------------------
                // String bereitstellen 
                // --------------------
                nmea_string := ('$GPRMC,085123,A,'   //time UTC
                           +LeftStr(llat,8)+
                     ','+
                                 chNS+
                     ','+
                     LeftStr(llon,9)+
                     ','+
                     chWE+
                     ','
                     +tas_string+
                     ','
                     +head_string+
                     ',130700,'+   //date
                     '000.0'+      //magnetic variation
                     ',W*');
                nmea_string :=     nmea_string + checksum(nmea_string) + #13#10;
                                      
                // --------------
                // console output
                // --------------
                If (pause = 1) and (firstTime = 1) Then Begin
                   Writeln('FS Simulator is paused...');
                   firstTime := 0;
                End;
                If (pause = 1) and (firstTime = 0) Then Begin
                   Write('.');
                End;
                if (pause = 0) Then begin
                   Writeln('    ' + alt_string + ' m       ' + lat_string + ' ' + chNS + 
                        '     ' + lon_string + ' ' + chWE + '         ' + tas_str + ' knots');
                   firstTime := 1;
                End;

                // ---------------
                // sending to COM1
                // ---------------
                   ComObj^.Com_SendString(nmea_string);                
                      
                // -----------
                // get lat/lon
                // -----------
                While Not IpcGetLat( IpcFs6, pfsInfo, llat, llon, lat_string, lon_string ) Do
                   Begin WriteLn('cannot read coords! start first FS2000! or just wait until FS2000 is ready again.'); end;  
                While Not IpcGetAll( IpcFs6, pFsInfo, heading, TAS, alt, pause) Do
                   Begin Writeln('cannot read infos!'); End;

                // -----
                // Sleep
                // -----
                Sleep(900);   

    Until C = #27;
 
    Dispose(ComObj, Done);                  { Dispose the communications object }

//////////////////////////////////////////////////////////////////////////////////////////////////////////!!
//!!Exec(GetEnv('COMSPEC'),'/C dir');
// checksum: writeln( checksum('$GPRMC,085126,A,4655.555,N,00729.693,E,051.0,270.0,130700,000.0,W*') );        //6F
End.